<?php

/**
 * The plugin bootstrap file
 *
 * This file is read by WordPress to generate the plugin information in the plugin
 * Dashboard. This file also includes all of the dependencies used by the plugin,
 * registers the activation and deactivation functions, and defines a function
 * this starts the plugin.
 *
 * @link:       http://www.eventregistrationpro.com
 * @since             1.0.9
 * @package           Event_Registration_Pro_Calendar
 *
 * @wordpress-plugin
 * Plugin Name:       Event Registration Pro Calendar
 * Plugin URI:        http://www.eventregistrationpro.com
 * Description:        Event Registration Pro Calendar is for accepting free and paid registrations to your events.
 * Version:           1.0.9
 * Author:            EventRegistrationPro.com
 * License:            GPL-3.0+
 * License URI:        http://www.gnu.org/licenses/gpl-3.0.txt
 * Text Domain:            event-registration-pro
 * Domain Path:            /languages
 */

// If this file is called directly, abort.
	if ( ! defined( 'WPINC' ) ) {
		die;
	}

	 global $r_path,$plg_text_domain;
	 $plugin_path=plugin_dir_path( __FILE__ );
	 $r_path= $_SERVER['DOCUMENT_ROOT'];
	 $core_plugin = plugin_basename( __FILE__ );
	 update_option('event_core_plugin_name',$core_plugin);
	 
	  define( 'ERP_EVENT_ORGANISER_DIR', plugin_dir_path( __FILE__ ) );
	 
	/**
	 * The code that runs during plugin activation.
	 */
	
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-event-registration-pro-activator.php';
	
	
	/**
	 * The code that runs during plugin deactivation.
	 */
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-event-registration-pro-deactivator.php';
	
	/** This action is documented in includes/class-event-registration-pro-activator.php */
	register_activation_hook( __FILE__, array( 'Event_Registration_Pro_Activator', 'activate' ) );
	
	/** This action is documented in includes/class-event-registration-pro-deactivator.php */
	register_deactivation_hook( __FILE__, array( 'Event_Registration_Pro_Deactivator', 'deactivate' ) );
	
	/**
	 * The core plugin class that is used to define internationalization,
	 * dashboard-specific hooks, and public-facing site hooks.
	 */
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-event-registration-pro.php';
	 require_once plugin_dir_path( __FILE__ ) . 'includes/main_function.php';
	
	/**
	 * Begins execution of the plugin.
	 *
	 * Since everything within the plugin is registered via hooks,
	 * then kicking off the plugin from this point in the file does
	 * not affect the page life cycle.
	 *
	 * @since    1.0.0
	 */

	function run_Event_Registration_Pro() {
	
	 
		$plugin = new Event_Registration_Pro();
		$plugin->run();
	
	}
	run_Event_Registration_Pro();


	add_action('init','ajax_fun_save');
	function ajax_fun_save(){
	
	$save_obj= new MainFuctionclass();
	$save_obj->MainSaveMethod();
	
	}	
	
	
	register_deactivation_hook( __FILE__, array( 'Event_Registration_Pro_Deactivator','deactivate_plugin') );
	//add_action('after_setup_theme', 'create_pages'); 
	
	
	//add_action('load-nav-menus.php', 'auto_nav_creation_primary');
	register_activation_hook(__FILE__,array( 'Event_Registration_Pro_Activator','auto_nav_creation_primary'));



/*cron job*/

	add_action('init', 'cron');
	
	function cron(){
		
	 global $post,$wpdb;
						
				$cat_metaq = get_option("erp_event_handling");
				$event_display_settings=array();
				 $event_display_settings = get_option("erp_event_display_settings"); 
				 $dateformat=$event_display_settings['erp_event_display_settings_formatdate']; 
				$args = array(
				'post_type' => 'erp_event',
				'posts_per_page'=> -1,
				'orderby' => 'ASC',	
												
					);
					 
				$crontest = new WP_Query( $args );
		   
			  $addeventdate=$cat_metaq['erp_event_handling_minus'][0];
			  if(empty($addeventdate)){$addeventdate=0;}
			  $cur_date=date('m/d/Y');
			  $cur_date_end =date('m/d/Y', strtotime($cur_date. ' + '.$addeventdate.' days'));
			
			
			 while( $crontest->have_posts() ) : $crontest->the_post();
			 
			
				  $testmeta =get_post_meta($post->ID);
				 
				   $cat_metaq['erp_event_handling_archiveby'];


				   $inc_event_start_date =date('Y-m-d', strtotime($testmeta['erp_event_date'][0]. ' + '.$addeventdate.' days'));

				   $inc_event_end_date =date('Y-m-d', strtotime( $testmeta['erp_event_enddate'][0]. '  + '.$addeventdate.' days'));



				  
				   if($cat_metaq['erp_event_handling_archiveby']== "Event start date"){
					   
					   if($cat_metaq['erp_event_handling_oldevent'] == "Archive old events"){
						  
						 
							if(strtotime($cur_date) > strtotime($inc_event_start_date)){
								
								if($post->post_status !='pending'){
										$wpdb->query($wpdb->prepare("UPDATE ".$wpdb->posts." SET post_status = %s where post_type = %s AND ID = %d",
										'archive', 'erp_event', $post->ID ) );
										do_action('change_duplicate_event',$post->ID);	
								}
							}
							
							if(strtotime($cur_date) < strtotime($inc_event_start_date) AND strtotime($cur_date) > strtotime($event_date)){
								
							$wpdb->query($wpdb->prepare("UPDATE ".$wpdb->posts." SET post_status = %s where post_type = %s AND ID = %d",
										'publish', 'erp_event', $post->ID ) );	
								
							}
					   }
						if($cat_metaq['erp_event_handling_oldevent'] == "Delete old events"){
						 
							if(strtotime($cur_date) > strtotime($inc_event_start_date)){
								
							$wpdb->query("delete FROM ".$wpdb->posts." where ID =".$post->ID);	
							do_action('change_duplicate_event',$post->ID);	  		
							}
							
							if(strtotime($cur_date) < strtotime($inc_event_start_date) AND strtotime($cur_date) > strtotime($event_date)){
								
							$wpdb->query($wpdb->prepare("UPDATE ".$wpdb->posts." SET post_status = %s where post_type = %s AND ID = %d",
										'publish', 'erp_event', $post->ID ) );	
								
							}
					   }
				   }
				   
				   if($cat_metaq['erp_event_handling_archiveby'] == "Event end date"){
					   
					
					   if($cat_metaq['erp_event_handling_oldevent'] == "Archive old events"){
						   
							if(strtotime($cur_date) > strtotime($inc_event_end_date)){
								
								if($post->post_status !='pending'){
										$wpdb->query($wpdb->prepare("UPDATE ".$wpdb->posts." SET post_status = %s where post_type = %s AND ID = %d",
										'archive', 'erp_event', $post->ID ) );
										do_action('change_duplicate_event',$post->ID);	
								}			  		
							} 
							
							if(strtotime($cur_date) < strtotime($inc_event_end_date) AND strtotime($cur_date) > strtotime($event_date)){
								
							$wpdb->query($wpdb->prepare("UPDATE ".$wpdb->posts." SET post_status = %s where post_type = %s AND ID = %d",
										'publish', 'erp_event', $post->ID ) );	
								
							}
					   }
						if($cat_metaq['erp_event_handling_oldevent'] == "Delete old events"){
						 
							if(strtotime($cur_date) > strtotime($inc_event_end_date)){
								
							$wpdb->query("delete FROM ".$wpdb->posts." where ID =".$post->ID);
							do_action('change_duplicate_event',$post->ID);		  		
							}
							
							if(strtotime($cur_date) < strtotime($inc_event_end_date) AND strtotime($cur_date) > strtotime($event_date)){
								
							$wpdb->query($wpdb->prepare("UPDATE ".$wpdb->posts." SET post_status = %s where post_type = %s AND ID = %d",
										'publish', 'erp_event', $post->ID ) );	
								
							}
					   }
				   }
			
				  
				  endwhile;
	}
	  
/*Close function*/  
/*Email template*/


 register_activation_hook(__FILE__, array( 'Event_Registration_Pro_Activator','insert_record_emails'));

/*cart page created and assign template*/

add_action('admin_init', 'fn_ea_create_admin_page');

	function fn_ea_create_admin_page() 
	{  
	
		    $pagecheck = 'Erp Print';		
				if( get_page_by_title( $pagecheck ) == NULL ){
					
					$createPage1 = array(
					  'post_title'    => $pagecheck,
					  'post_content'  => '',
					  'post_status'   => 'publish',
					  'post_author'   => 1,
					  'post_type'     => 'page',
					  'post_name'     => $pagecheck
					);
			
					// Insert the post into the database  
					$page_id =  wp_insert_post( $createPage1 );
					update_option( 'event_print_page_id', $page_id );  
					//Assign Template
					update_post_meta($page_id,'_wp_page_template','erp_event_print.php');
				}		
			$pagecheck = 'Erp Rssfeed';
		
				if( get_page_by_title( $pagecheck ) == NULL ){
					
					$createPage1 = array(
					  'post_title'    => $pagecheck,
					  'post_content'  => '',
					  'post_status'   => 'publish',
					  'post_author'   => 1,
					  'post_type'     => 'page',
					  'post_name'     => $pagecheck
					);
			
					// Insert the post into the database  
					$page_id =  wp_insert_post( $createPage1 );
					 update_option( 'event_rss_page_id', $page_id );  
					//Assign Template
					update_post_meta($page_id,'_wp_page_template','erp_rssfeed.php');
				}
			$event_general_settings=array();
			$event_general_settings=get_option('erp_event_general_settings');

			$cat_page=$event_general_settings['erp_event_general_settings_category_page_url'];
			
			if(empty($cat_page)){ 
				$page = get_page_by_title('Event Category');
				$page_id = $page->ID;
				$event_general_settings['erp_event_general_settings_category_page_url']=$page_id;
			}
			 $acc_cat_page=$event_general_settings['erp_event_general_settings_cat_accor_page_url'];
			if(empty($acc_cat_page)){ 
				$page = get_page_by_title('Category Accordion');
				$page_id = $page->ID;
				$event_general_settings['erp_event_general_settings_cat_accor_page_url']=$page_id;
			}
			$cal_page=$event_general_settings['erp_event_general_settings_calendar_page_url'];
			if(empty($cal_page)){ 
				$page = get_page_by_title('Calendar');
				$page_id = $page->ID;
				$event_general_settings['erp_event_general_settings_calendar_page_url']=$page_id;
			}
			$list_page=$event_general_settings['erp_event_general_settings_list_page_url'];
			if(empty($list_page)){ 
				$page = get_page_by_title('Event List');
				$page_id = $page->ID;
				$event_general_settings['erp_event_general_settings_list_page_url']=$page_id;
			}
			$thank_page=$event_general_settings['erp_event_general_settings_thankyou_page_url'];
			if(empty($thank_page)){
				$page = get_page_by_title('Thankyou');
				$page_id = $page->ID;
				$event_general_settings['erp_event_general_settings_thankyou_page_url']=$page_id;
			}
			$check_page=$event_general_settings['erp_event_general_settings_checkout_page_url'];
			if(empty($check_page)){
				$page = get_page_by_title('Erp Checkout');
				$page_id = $page->ID;
				$event_general_settings['erp_event_general_settings_checkout_page_url']=$page_id;
			}
			$cart_page=$event_general_settings['erp_event_general_settings_cart_page_url'];
			if(empty($cart_page)){
				$page = get_page_by_title('Erp Cart');
				$page_id = $page->ID;
				$event_general_settings['erp_event_general_settings_cart_page_url']=$page_id;
			}
		    update_option('erp_event_general_settings',$event_general_settings); 

				
	}
	
	add_filter('theme_page_templates','fn_ea_add_page_template4');
	//Load Template at Admin side in the right sidebar of page
	function fn_ea_add_page_template4($templates) 
	{
		$templates['erp_event_print.php'] = 'Erp Print';
		return $templates;
	}
	add_filter('theme_page_templates','fn_ea_add_page_template3');
	//Load Template at Admin side in the right sidebar of page
	function fn_ea_add_page_template3($templates) 
	{
		$templates['erp_rssfeed.php'] = 'RSS FEED';
		return $templates;
	}
	


	
	add_action('page_template','fn_page_template');
	function fn_page_template($template) 
	{  
		$template_name = get_page_template_slug( get_the_ID() );
		
		if('erp_event_print.php' == $template_name)
		{ 
			$template = plugin_dir_path( __FILE__ ) . '/templates/erp_event_print.php'; 
			return $template;
		}
		if('erp_rssfeed.php' == $template_name)
		{ 
			$template = plugin_dir_path( __FILE__ ) . '/templates/erp_rssfeed.php'; 
			return $template;
		}else{
			
			return $template;
		}
		
	}


	add_action('init','cron_url_set');
	function cron_url_set(){
		  $home_url=get_site_url();
		
		  $current_url = "http://".$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
		  
		   $sendcron_url=get_site_url().'/events/?cron_task=cron_mail';
		   
		if($current_url==$sendcron_url){
			include (plugin_dir_path( __FILE__ ) . '/templates/erp_cron.php'); 
			
		}
	}
	
	
	
	add_action('init','create_addon_plugin');
	function create_addon_plugin(){
		$sql_tbl_addon = "CREATE TABLE IF NOT EXISTS `erp_addon_plg_tbl` (
		  `addon_plg_id` int(11) NOT NULL AUTO_INCREMENT,
		  `plg_name` varchar(250) COLLATE utf8mb4_unicode_ci NOT NULL,
		  `action` varchar(250) COLLATE utf8mb4_unicode_ci NOT NULL,
		  `status` int(10) COLLATE utf8mb4_unicode_ci NOT NULL,
		 
		  PRIMARY KEY (`addon_plg_id`)
		) ENGINE=MyISAM  DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci AUTO_INCREMENT=1 ;";
		
		require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
		dbDelta( $sql_tbl_addon );	
	}
	
	add_action( 'wp_ajax_cat_limit_change', 'prefix_ajax_cat_limit_change' );
	
	function prefix_ajax_cat_limit_change() {
		// Handle request then generate response using WP_Ajax_Response
	  if ( !wp_verify_nonce( sanitize_text_field($_POST['nonce']), 'erp-nonce' ) ){
					echo 'false';die;
			   }
		$display_settings=get_option('erp_event_display_settings');		
		$display_settings['erp_event_display_settings_cats_limit'] =sanitize_text_field($_POST['data']);
		update_option('erp_event_display_settings',$display_settings);
	  die;
	}

/*
	 * Matches each symbol of PHP date format standard
	 * with jQuery equivalent codeword
	 * @author Tristan Jahier
	 */
	function dateformat_PHP_to_jQueryUI($php_format)
	{
		$SYMBOLS_MATCHING = array(
			// Day
			'd' => 'dd',
			'D' => 'D',
			'j' => 'd',
			'l' => 'DD',
			'N' => '',
			'S' => '',
			'w' => '',
			'z' => 'o',
			// Week
			'W' => '',
			// Month
			'F' => 'MM',
			'm' => 'mm',
			'M' => 'M',
			'n' => 'm',
			't' => '',
			// Year
			'L' => '',
			'o' => '',
			'Y' => 'yy',
			'y' => 'y',
			// Time
			'a' => '',
			'A' => '',
			'B' => '',
			'g' => '',
			'G' => '',
			'h' => '',
			'H' => '',
			'i' => '',
			's' => '',
			'u' => ''
		);
		$jqueryui_format = "";
		$escaping = false;
		for($i = 0; $i < strlen($php_format); $i++)
		{
			$char = $php_format[$i];
			if($char === '\\') // PHP date format escaping character
			{
				$i++;
				if($escaping) $jqueryui_format .= $php_format[$i];
				else $jqueryui_format .= '\'' . $php_format[$i];
				$escaping = true;
			}
			else
			{
				if($escaping) { $jqueryui_format .= "'"; $escaping = false; }
				if(isset($SYMBOLS_MATCHING[$char]))
					$jqueryui_format .= $SYMBOLS_MATCHING[$char];
				else
					$jqueryui_format .= $char;
			}
		}
		return $jqueryui_format;
	}




/* ============= tables installation =================*/


add_shortcode('Calendar_View','calendarview');	
function calendarview(){
	ob_start();
	include('public/erp-front-event-calendar.php');
	$result = ob_get_contents();
	ob_end_clean();
    return $result;
}


add_shortcode( 'Event_List', 'all_event_list' );
function all_event_list(){
	ob_start();
	include('public/erp-front-event-list.php');
	$result = ob_get_contents();
	ob_end_clean();
    return $result;
}
add_shortcode('Event_Category_Accordion','EventCategoryAccordion');
function EventCategoryAccordion(){
	ob_start();
	include('public/erp-front-category-accordion.php');
	$result = ob_get_contents();
	ob_end_clean();
    return $result;
	}
add_shortcode('Event_Category','EventCategory');
function EventCategory(){
	ob_start();
	include('public/erp-front-event-category.php');
	$result = ob_get_contents();
	ob_end_clean();
    return $result;
	}
add_shortcode('Event_Checkout','EventCheckout');
function EventCheckout(){
	ob_start();
	include('templates/erp_checkout.php');
	$result = ob_get_contents();
	ob_end_clean();
    return $result;
	}
add_shortcode('Event_Cart','EventCart');
function EventCart(){
	ob_start();
	include('templates/erp_cart.php');
	$result = ob_get_contents();
	ob_end_clean();
    return $result;
	}
add_shortcode('Event_Thankyou','EventThankyou');
function EventThankyou(){
	ob_start();
	include('templates/erp_thankyou.php');
	$result = ob_get_contents();
	ob_end_clean();
    return $result;
	}		
/*Dateformat funcction*/

	function dateformat_function($e_date){
		
		$event_display_settings=array();
		$event_display_settings = get_option("erp_event_display_settings"); 
		$dateformat=$event_display_settings['erp_event_display_settings_formatdate']; 

			return $val_date=date($dateformat, strtotime($e_date));
	
	}
	/*erp_event_sort default date*/
add_action( 'pre_get_posts','erp_event_sort_date');
function erp_event_sort_date($query){
	global $wpdb;
	if($_GET['post_type']=='erp_event'){ 
	 if( is_admin() && $query->is_main_query()) {
			$orderby = trim(strip_tags(sanitize_text_field($_GET['orderby'])));
			$post_type = trim(strip_tags(sanitize_text_field($_GET['post_type'])));
			$post_status = trim(strip_tags(sanitize_text_field($_GET['post_status'])));
			$query->set( 'meta_key', 'erp_event_date' );
			 if($post_type=='erp_event' && $post_status !='trash'){
				if(empty($orderby)){
				 	$query->set( 'orderby', 'meta_value' );
				 	$query->set( 'meta_key', 'erp_event_date' );
				 	$query->set( 'order', 'ASC' );
			 	}

			 }
		}
	}	

}
/*For Wp table sort*/
function cf_join($join)
{
	if( is_admin() ) {

		global $wpdb;
		$type = trim(strip_tags($_REQUEST['post_type']));  
		$orderby_type = trim(strip_tags($_REQUEST['orderby']));

		if($type=='erp_event' && $orderby_type=='erp_event_location')
		{ 
			$join .=' LEFT OUTER JOIN '.$wpdb->postmeta. ' mt2 ON '. $wpdb->posts . '.ID = mt2.post_id ';
			$join .=' LEFT OUTER JOIN '.$wpdb->posts. ' L1 ON L1.ID = mt2.meta_value '; 
		}
		if($type=='erp_event' && $orderby_type=='erp_event_category')
		{ 
			$join .=' LEFT JOIN '.$wpdb->postmeta. ' mt2 ON '. $wpdb->posts . '.ID = mt2.post_id ';
			$join .=' LEFT OUTER JOIN '.$wpdb->terms. ' T1 ON T1.term_id = mt2.meta_value '; 
		}
		if($type=='erp_event' && $orderby_type=='erp_event_date')
		{ 
			 $join .=' LEFT JOIN '.$wpdb->postmeta. ' mt2 ON '. $wpdb->posts . '.ID = mt2.post_id ';
		} 
	}
	return $join;
}
add_filter('posts_join', 'cf_join' );

/*end wp sort table*/
/*For Wp table sort*/
function posts_where( $where ) {

	if( is_admin() ) {

		global $wpdb;

		$type = trim(strip_tags($_REQUEST['post_type']));  
		$orderby_type = trim(strip_tags($_REQUEST['orderby']));

		if($type=='erp_event' && $orderby_type=='erp_event_location')
		{
			$where .= " AND  mt2.meta_key = 'erp_event_location' ";
		}  
		if($type=='erp_event' && $orderby_type=='erp_event_category')
		{
			$where .= " AND  mt2.meta_key = 'erp_event_category' ";
		} 
		if($type=='erp_event' && $orderby_type=='erp_event_date')
		{
			$where .= " AND  mt2.meta_key = 'erp_event_date' ";
		} 

	}
 
	return $where;
}		
add_filter('posts_where', 'posts_where' );

/*end wp sort table*/


/**
 * Starts the ball rolling
 */
add_action('init','erp_init');
function erp_init() {
	
	add_action( 'template_redirect', 'erp_setup_hooks', erp_highest_priority( 'template_redirect' ) );
	
}


function erp_add_filter( $filter, $priority = 10, $accepted_args = 1 ) {
	add_filter( $filter, $filter, $priority, $accepted_args );
}

function erp_remove_filter( $filter, $priority = 10 ) {
	remove_filter( $filter,  $filter , $priority );
}

function erp_setup_hooks() {

	add_filter( 'template_include', 'erp_template_include', erp_highest_priority( 'erp_template_include' )  );
}

/**
 * Given a tag returns the highest existing callback priority + 1
 */
function erp_highest_priority( $tag ) {
	global $wp_filter;  

	

	if ( isset( $wp_filter[$tag] ) ) {
		if ( is_array( $wp_filter[$tag] ) ) {
			return max( array_keys( $wp_filter[$tag] ) ) + 1;
		} elseif ( $wp_filter[$tag] instanceof WP_Hook && is_array( $wp_filter[$tag]->callbacks ) ) {
			//@see https://core.trac.wordpress.org/ticket/17817
			return max( array_keys( $wp_filter[$tag]->callbacks ) ) + 1;
		} else {
			return 9999;
		}
	}

	return 1;
}


/**
 * Main body of the class. If theme compatability is enabled and it is an events page (not
 * single event), and no appropriate template has been found we create a dummy post, and use
 * the page.php template. The content of the dummy post is the events loop.
 */
function erp_template_include( $template ) {
   
  	

	/*
	 * In view of theme compatibility, if an event template isn't found
	 * rather than using our own single-event.php, we use ordinary single.php and
	 * add content in via the_content
	 */
	if ( is_singular( 'erp_event' ) && ! erp_eventorganiser_is_event_template( $template, 'erp_event' ) ) {
		//Viewing a single event

		//Hide next/previous post link
		add_filter( 'next_post_link', '__return_false' );
		add_filter( 'previous_post_link', '__return_false' );

		//Prepend our event details
		add_filter( 'the_content', '_erp_eventorganiser_single_event_content' );
		//$const_template = plugin_dir_path( __FILE__ ) . '/templates/category-page-template.php';
		return $template;
	} 

	// If an appropriate template has been found, we'll just stop here
	if ( is_post_type_archive( 'erp_event' ) && erp_eventorganiser_is_event_template( $template, 'archive' ) ) {
		return $template;
	} 

	if ( is_tax( 'erp-event-category' )  && erp_eventorganiser_is_event_template( $template, 'erp-event-category' ) ) {
		return $template;
	}
 

	/*if ( 'themecompat' !== erp_eventorganiser_get_option( 'templates' )  ) {
		//Not in theme compat - just fallback to the plug-in's default templates

		if ( is_post_type_archive( 'erp_event' ) ) {
			$template = $template;
		} 

		if ( is_tax( 'erp-event-category' ) ) {
			$template = $template;
		}

 		return $template;
	}*/

	//We only care about events/venue/category/tag pages
	if ( ! is_post_type_archive( 'erp_event' ) && ! is_tax( 'erp-event-category' )  ) {
		return $template;
	}

	// Get the labels for the event post type:
	$labels = get_post_type_labels( get_post_type_object( 'erp_event' ) );

	//Set the title, and where appropriate, pre-content (term description, venue map etc).
	$precontent = false;
	 

	$title =  $labels->name;

	//Set the content - this is just the events loop.
	$priority = max( 10, erp_highest_priority( 'post_class' ) );
	erp_add_filter( 'post_class', $priority, 10, 3 ); //Injecting our eo-tc-event class
	ob_start();
	erp_eo_get_template_part( 'category-page-template' );
	$content = ob_get_clean();
	erp_remove_filter( 'post_class', $priority );

	//Create the dummy post
	erp_reset_post( array(
		'eo_theme_compat' => true,
		'post_title'      => $title,
		'post_content'    => $precontent . $content,
		'post_excerpt'    => $precontent . $content,
		'post_type'       => 'event',
		'comment_status'  => 'closed',
		'is_archive'      => true,
	) );

	//If triggered these remove all callbacks (including two below) so that the content is set as above
	//Not all theme page.php templates contain a loop. In which case, we fallback to the two callbacks below
	add_action( 'loop_start', 'erp_remove_content_filters',  9999 );
	add_action( 'loop_end',   'erp_restore_content_filters',   -9999 );

	//Fallback to ensure the content is as set above
	add_filter( 'the_content', 'erp_replace_page_content', erp_highest_priority( 'the_content' ) );
	add_filter( 'the_excerpt', 'erp_replace_page_content', erp_highest_priority( 'the_excerpt' ) );

	//Injecting our eo-tc-page class - use (dummy) post and body class as theme might not call one or the other
	add_filter( 'post_class', 'erp_post_class_events_page', $priority, 3 );
	add_filter( 'body_class', erp_highest_priority( 'body_class' ), 2 );

	//Load template
	$template = locate_template( erp_get_theme_compat_templates() );

	//Ensure our styles are loaded
	//add_action( 'wp_footer', 'erp_load_styles' );
	//$this->load_styles(); 

	return $template;

}


/**
 * Checks if provided template path points to an 'event' template recognised by EO, given the context.
 * This will one day ignore context, and if only the event archive template is present in theme folder
 * it will use that  regardless. If no event-archive tempate is present the plug-in will pick the most appropriate
 * option, first from the theme/child-theme directory then the plugin.
 *
 * @ignore
 * @since 1.3.1
 *
 * @param string $templatePath absolute path to template or filename (with .php extension)
 * @param string $context What the template is for ('event','archive-event','event-venue', etc).
 * @return (true|false) return true if template is recognised as an 'event' template. False otherwise.
 */
function erp_eventorganiser_is_event_template( $templatepath, $context = '' ) {

	//echo '<hr>......aa'. $template = basename( $templatepath );
   // echo '<hr>......cc'.$context;die;
    switch ( $context ) {
		case 'erp_event';
			return (1 == preg_match( '/^post-page-template((-(\S*))?).php/', $template )); 
		case 'erp-event-category':
			return (1 == preg_match( '/^category-page-template((-(\S*))?).php/', $template )); 

		
	}

	return false;
	
	  
}

/*

function erp_eventorganiser_get_option( $option = false, $default = false ) {

	$defaults = array(
		'url_event' => 'events/event',
		'url_events' => 'events/event',
		'url_venue' => 'events/venue',
		'url_cat' => 'events/category',
		'url_tag' => 'events/tag',
		'url_on' => 'on',
		'navtitle' => __( 'Events', 'eventorganiser' ),
		'group_events' => '',
		'feed' => 1,
		'deleteexpired' => 0,
		'supports' => array( 'title', 'editor', 'author', 'thumbnail', 'excerpt', 'custom-fields', 'eventtag', 'event-venue' ),
		'event_redirect' => 'events',
		'dateformat' => 'd-m-Y',
		'prettyurl' => 1,
		'templates' => 'themecompat',
		'addtomenu' => 0,
		'menu_item_db_id' => 0,
		'excludefromsearch' => 0,
		'showpast' => 0,
		'runningisnotpast' => 0,
		'hide_addon_page' => 0,
		'disable_css' => 0,
		'google_api_key' => false,
		'map_provider' => 'openstreetmap'
	);
	$options = get_option( 'eventorganiser_options', $defaults );
	$options = wp_parse_args( $options, $defaults );

	$options['supports'][] = 'event-venue';

	$options = apply_filters( 'eventorganiser_options', $options );

	if ( false === $option ) {
		return $options;
	}

	/* Backwards compatibility for 'eventag' option *
	if ( 'eventtag' === $option ) {
		return in_array( 'eventtag', $options['supports'] );
	}

	if ( 'dateformat' === $option ) {
		//Backwards compatibility (migration from mm-dd/dd-mm to php format):
		if ( 'mm-dd' == $options[$option] ) {
			$options[$option] = 'm-d-Y';
		} elseif ( 'dd-mm' == $options[$option] ) {
			$options[$option] = 'd-m-Y';
		}
	}

	if ( ! isset( $options[$option] ) ) {
		return $default;
	}

	return $options[$option];
}
*/


function _erp_eventorganiser_single_event_content( $content ) {

	//Sanity check!
	if ( ! is_singular( 'erp_event' ) ) {
		return $content;
	}

	//Check we are an event!
	if ( get_post_type( get_the_ID() ) !== 'erp_event' ) {
		return $content;
	}
$content=include_once(plugin_dir_path( __FILE__ ) . '/templates/post-page-template.php');/*

	//Object buffering
	ob_start();
	//erp_eo_get_template_part( 'event-meta','event-single' );
	erp_eo_get_template_part( 'post-page-template' );
	//include(ERP_EVENT_ORGANISER_DIR.'templates/post-page.php');
	//include_once(plugin_dir_path( __FILE__ ) . '/templates/post-page-template.php')
	$event_details = ob_get_contents();
	ob_end_clean();

	
	 $event_details = apply_filters( 'erp_eventorganiser_pre_event_content', $event_details, $content );

	return $event_details . $content;//*/
} 


/**
 * Creates a dummy post modifies the globals $wp_query, $post
 */
function erp_reset_post( $args ) {

	global $wp_query, $post;

	// Switch defaults if post is set
	if ( false ) {
		$dummy = wp_parse_args( $args, array(
			'ID'                    => $wp_query->post->ID,
			'post_status'           => $wp_query->post->post_status,
			'post_author'           => $wp_query->post->post_author,
			'post_parent'           => $wp_query->post->post_parent,
			'post_type'             => $wp_query->post->post_type,
			'post_date'             => $wp_query->post->post_date,
			'post_date_gmt'         => $wp_query->post->post_date_gmt,
			'post_modified'         => $wp_query->post->post_modified,
			'post_modified_gmt'     => $wp_query->post->post_modified_gmt,
			'post_content'          => $wp_query->post->post_content,
			'post_title'            => $wp_query->post->post_title,
			'post_excerpt'          => $wp_query->post->post_excerpt,
			'post_content_filtered' => $wp_query->post->post_content_filtered,
			'post_mime_type'        => $wp_query->post->post_mime_type,
			'post_password'         => $wp_query->post->post_password,
			'post_name'             => $wp_query->post->post_name,
			'guid'                  => $wp_query->post->guid,
			'menu_order'            => $wp_query->post->menu_order,
			'pinged'                => $wp_query->post->pinged,
			'to_ping'               => $wp_query->post->to_ping,
			'ping_status'           => $wp_query->post->ping_status,
			'comment_status'        => $wp_query->post->comment_status,
			'comment_count'         => $wp_query->post->comment_count,
			'filter'                => $wp_query->post->filter,
			'is_404'                => false,
			'is_page'               => false,
			'is_single'             => false,
			'is_archive'            => false,
			'is_tax'                => false,
		) );
	} else {
		$dummy = wp_parse_args( $args, array(
			'ID'                    => -9999,
			'post_status'           => 'publish',
			'post_author'           => 0,
			'post_parent'           => 0,
			'post_type'             => 'page',
			'post_date'             => 0,
			'post_date_gmt'         => 0,
			'post_modified'         => 0,
			'post_modified_gmt'     => 0,
			'post_content'          => '',
			'post_title'            => '',
			'post_excerpt'          => '',
			'post_content_filtered' => '',
			'post_mime_type'        => '',
			'post_password'         => '',
			'post_name'             => '',
			'guid'                  => '',
			'menu_order'            => 0,
			'pinged'                => '',
			'to_ping'               => '',
			'ping_status'           => '',
			'comment_status'        => 'closed',
			'comment_count'         => 0,
			'filter'                => 'raw',
			'is_404'                => false,
			'is_page'               => false,
			'is_single'             => false,
			'is_archive'            => false,
			'is_tax'                => false,
		) );
	}

	// Bail if dummy post is empty
	if ( empty( $dummy ) ) {
		return;
	}

	// Set the $post global
	$post = new WP_Post( (object) $dummy );
	$shadow_post = $post;

	// Copy the new post global into the main $wp_query
	$wp_query->post       = $post;
	$wp_query->posts      = array( $post );

	// Prevent comments form from appearing
	$wp_query->post_count = 1;
	$wp_query->is_404     = $dummy['is_404'];
	$wp_query->is_page    = $dummy['is_page'];
	$wp_query->is_single  = $dummy['is_single'];
	$wp_query->is_archive = $dummy['is_archive'];
	$wp_query->is_tax     = $dummy['is_tax'];

	$wp_query->is_singular = $wp_query->is_single;

	// Clean up the dummy post
	unset( $dummy );

	if ( ! $wp_query->is_404() ) {
		status_header( 200 );
	}

}


/**
 * A list of templates that we will try to use (in the order they are attempted)
 * This is filterable via `eventorganiser_theme_compatability_templates`
 */
function erp_get_theme_compat_templates() {
	$templates = array( 
		'page.php',
		'single.php',
		'index.php',
	);

	$templates = apply_filters( 'erp_eventorganiser_theme_compatability_templates', $templates );

	return $templates;
}


function erp_eo_get_template_part( $slug, $name = null ) {

	/**
	 * @ignore
	 */
	//echo '<hr>gggggggggg............'.$slug;die;
	do_action( "get_template_part_{$slug}", $slug, $name );

	$templates = array();
	if ( isset( $name ) ) {
		$templates[] = "{$slug}-{$name}.php";
	}

	$templates[] = "{$slug}.php";

	erp_eo_locate_template( $templates, true, false );
}


function erp_eo_locate_template( $template_names, $load = false, $require_once = true ) {
	$located = '';

	$template_dir = get_stylesheet_directory(); //child theme
	$parent_template_dir = get_template_directory(); //parent theme
	$stack = array( $template_dir, $parent_template_dir, ERP_EVENT_ORGANISER_DIR   . 'templates' );

	/**
	 * Filters the template stack: an array of directories the plug-in looks for
	 * for templates.
	 *
	 * The directories are checked in the order in which they appear in this array.
	 * By default the array includes (in order)
	 *
	 *  - child theme directory
	 *  - parent theme directory
	 *  - `event-organiser/templates`
	 *
	 * @param array $stack Array of directories (absolute path).
	 */
	$stack = apply_filters( 'eventorganiser_template_stack', $stack );
	$stack = array_unique( $stack );

	foreach ( (array) $template_names as $template_name ) {
		if ( ! $template_name ) {
			continue;
		}
		foreach ( $stack as $template_stack ) {
			if ( file_exists( trailingslashit( $template_stack ) . $template_name ) ) {
				$located = trailingslashit( $template_stack ) . $template_name;
				break;
			}
		}
	}

	if ( $load && '' != $located ) {
		load_template( $located, $require_once );
	}
// $located;
	return $located;
} 

/**
 * Removes all filters for the dummy page content
 * May not be called, in which case we fallback on replace_page_content();
 */
function erp_remove_content_filters( $query ) {
	$the_post = $query->post;
	//if ( $shadow_post->ID === $the_post->ID && ! empty( $the_post->eo_theme_compat ) ) {
		erp_remove_filters( 'the_excerpt' );
		erp_remove_filters( 'get_the_excerpt' );
		erp_remove_filters( 'the_content' );
	//}
}


/**
 * Restores all removed filters
 * May not be called
 */
function erp_restore_content_filters( $query ) {
	$the_post = $query->post;
	//if ( $shadow_post->ID === $the_post->ID && ! empty( $the_post->eo_theme_compat ) ) {
		erp_restore_filters( 'the_excerpt' );
		erp_restore_filters( 'get_the_excerpt' );
		erp_restore_filters( 'the_content' );
	//}
}

/**
 * Enqueues the front-end stylesheet
 */
/*function erp_load_styles() {
	wp_enqueue_style( 'erp_eo_front' );
}*/


/**
 * Remove all callbacks for a particular hook $tag.
 */
function erp_remove_filters( $tag ) {

	global $wp_filter, $merged_filters;

	//Filters exist
	if ( isset( $wp_filter[$tag] ) ) {

		// Store filters in a backup
		$wp_filter[$tag] = $wp_filter[$tag];

		// Unset the filters
		unset( $wp_filter[$tag] );
	}

	// Check merged filters
	if ( isset( $merged_filters[$tag] ) ) {

		// Store filters in a backup
		$merged_filters[$tag] = $merged_filters[$tag];

		// Unset the filters
		unset( $merged_filters[$tag] );
	}

}

/**
 * Restores all callbacks for a particular hook $tag.
 */
function erp_restore_filters( $tag ) {

	global $wp_filter, $merged_filters;

	if ( isset( $wp_filter[$tag] ) ) {
		// Store filters in a backup
		$wp_filter[$tag] = $wp_filter[$tag];
		// Unset the filters
		unset( $wp_filter[$tag] );
	}

	// Check merged filters
	if ( isset( $merged_filters[$tag] ) ) {
		// Store filters in a backup
		$merged_filters[$tag] = $merged_filters[$tag];
		// Unset the filters
		unset( $merged_filters[$tag] );
	}
	return true;

}

/**
 * Ensure dummy page content is as we want it
 */
function erp_replace_page_content( $content ) {
	global $post;

	if ( $shadow_post->ID === $post->ID && ! empty( $post->eo_theme_compat ) ) {
		return $shadow_post->post_content;
	}

	return $content;
} 

/**
 * Injects 'eo-tc-page' class to dummy post in theme compatabilty mode.
 */
function erp_post_class_events_page( $classes, $class, $post_id ) {
	global $post;

	if ( $shadow_post->ID === $post_id && ! empty( $post->eo_theme_compat ) ) {
		$classes[] = 'eo-tc-page';
	}

	return $classes;
}
/* Add short code to below pages*/
//add_action( 'admin_init', 'add_page_content' );
/*End pages*/
add_action('admin_init','erp_event_list_table');
function erp_event_list_table(){
	foreach( array( 'edit-erp_event' ) as $hook ){
		add_filter( "views_$hook" , 'fn_custom_view_count', 10, 1);	 
	}
}

function fn_custom_view_count( $views ) 
		{
			global $current_screen;
			if($current_screen->post_type!='edit-erp_event'){
				switch( $current_screen->id ) 
				{ 
					case 'edit-erp_event':
						$views = fn_manipulate_views( 'erp_event', $views );
						break; 
				}
			}

			return $views;
		}
		function fn_manipulate_views( $what, $views )
		{
			global $user_ID, $wpdb;
			/*
			 * This needs refining, and maybe a better method
			 * e.g. Attachments have completely different counts  
			 */  
			//Total   
			$args = array(
				'post_type'  => $what,
				'post_status' => array('publish','archive', 'pending', 'draft', 'future', 'private', 'inherit', 'trash'),    
				'meta_query' => array(
					array(
						'key' => 'erp_event_date',
						'compare' => 'EXISTS' 
					)
				)
			);
			$posts = new WP_Query( $args );
			$total = $posts->found_posts; 					
			//Publish
			$args = array(
				'post_type'  => $what,
				'post_status' => 'publish',
				'meta_query' => array(
					array(
						'key' => 'erp_event_date',
						'compare' => 'EXISTS' 
					)
				)
			);

    		$posts = new WP_Query( $args );
			$publish = $posts->found_posts; 
			//Drafts
			$args = array(
				'post_type'  => $what,
				'post_status' => 'draft',
				'meta_query' => array(
					array(
						'key' => 'erp_event_date',
						'compare' => 'EXISTS' 
					)
				)
			);

			$posts = new WP_Query( $args );
			$draft = $posts->found_posts; 

			//Pending
			$args = array(
   				'post_type'  => $what,
				'post_status' => 'pending',
				'meta_query' => array(
					array(
						'key' => 'erp_event_date',
						'compare' => 'EXISTS' 
					)
				)
			);
			$posts = new WP_Query( $args );
			$pending = $posts->found_posts;  
			//Trash
			$args = array(
				'post_type'  => $what,
				'post_status' => 'trash',
				'meta_query' => array(
					array(
						'key' => 'erp_event_date',
						'compare' => 'EXISTS' 
					)
				)

			);

			$posts = new WP_Query( $args );
			$a = $posts->found_posts; 

			$args = array(
				'post_type'  => $what,
				'post_status' => 'archive',
				'meta_query' => array(
					array(
						'key' => 'erp_event_date',
						'compare' => 'EXISTS' 
					)
				)

			);

			$posts = new WP_Query( $args );
			$archive = $posts->found_posts; 
			/*
			 * Only tested with Posts/Pages
			 * - there are moments where Draft and Pending shouldn't return any value
			 */
			$views['all'] = preg_replace( '/\(.+\)/U', '('.$total.')', $views['all'] ); 
			$views['publish'] = preg_replace( '/\(.+\)/U', '('.$publish.')', $views['publish'] ); 
			$views['draft'] = preg_replace( '/\(.+\)/U', '('.$draft.')', $views['draft'] ); 
  
			if($trash > 0){
				$views['trash'] = preg_replace( '/\(.+\)/U', '('.$trash.')', $views['trash'] ); 
			}
			if($pending > 0){

				$views['pending'] = preg_replace( '/\(.+\)/U', '('.$pending.')', $views['pending'] ); 

			} 
			if($archive > 0){

				$views['archive'] = preg_replace( '/\(.+\)/U', '('.$archive.')', $views['archive'] ); 

			} 
			return $views;

	}
