<?php
if ( ! defined( 'ABSPATH' ) ) exit;

class Event_Registration_Pro_Event_CPT_Manager {

	/**
	 * Gets all the plugins stored as a Event_Registration_Pro_Event_CPT Custom Post Type.
	 *
	 * @since    1.0.0
	 */
	public function get_all() {

		$args = array (
			'post_type'              => 'erp_event',
			'post_status'            => 'publish',
			'pagination'             => false,
			'order'                  => 'DESC',
			'orderby'                => 'title',
			'cache_results'          => true,
			'update_post_meta_cache' => true,
			'update_post_term_cache' => true,
			'posts_per_page'         => -1
		);
		
		$query = new WP_Query( $args );
		
		if ( false == $query->have_posts() ) {
			return array();
		}
		
		return $query->posts;
	
	}

}
